*-------------------------------------------------------------------------------
*-- Program.....: yadbmu.prg
*-- Programmer..: Bowen Moursund
*-- Date........: 08-20-1992
*-- Written for.: dBASE IV v1.5
*-- Notes.......: Yadbmu (re)compiles a subdirectory's DB4 source files.
*--               It makes use of search.bin to populate a temporary DBF
*--               with directory info. Search.Bin is created on the fly if
*--               the parm cBinPath = "" or the bin can't be found; loaded
*--               from disk if the parm correctly points to it. Temporary
*--               files are created in the DBTMP spill directory.
*-- Rev. History: 04-15-1992 - original program
*--               06-24-1992 - Bin loading, RunTime validation,
*--                            Qedit options added
*--               07-23-1992 - modified to use array rather than temp DBF
*--                          - modified to compile FMTs and QBEs
*--               08-05-1992 - minor bug fixes and enhancements
*--               08-20-1992 - procedures/functions renamed to avoid
*--                            conflicts with SYSPROC routines
*-- Usage.......: do Yadbmu with <cBinPath>, <lQedit>
*-- Examples....: do Yadbmu with "d:\dbase4\", .t.
*--               do Yadbmu with "", .t.
*--               do Yadbmu
*-- Parameters..: cBinPath = the path to search.bin with trailing \, or ""
*--               lQedit = .T. or .F. - Use Qedit for edit if cerror() occurs.
*--                                     Q.exe must be on the DOS PATH.
*-------------------------------------------------------------------------------

parameters cBinPath, lQedit

cTalkStat=set("TALK")
set talk off
if verlevel() < 1.5
    ? chr(7)
    ? "YADBMU runs only on dBASE IV v1.5."
    set talk &cTalkStat.
    cancel   && I know, unstructured, so sue me!
endif

set cursor off
cStatStat=set("STATUS")
set status off
cDeleStat = set("DELETED")
set deleted on
cSafeStat = set("SAFETY")
set safety off

do YadMenu

cDBTMP = ""
if type("cBinPath") = "C"
    if "" # cBinPath
        cBIN = cBinPath + "search"
        cModule = "search"
        if .not. file(cBIN + ".bin")
            store YadTemp("bin",.t.) to cBIN, cModule
            lBIN = .f.
        else
            lBIN = .t.
        endif
    else
        store YadTemp("bin",.t.) to cBIN, cModule
        lBIN = .f.
    endif
else
    store YadTemp("bin",.t.) to cBIN, cModule
    lBIN = .f.
endif
cTmpReName = YadTemp("tmp") + ".tmp"
if "" # cDBTMP .and. .not. lBIN
    cBIN = cDBTMP + "\" + cBIN
endif

cSkeleton="*.??G       "
declare aButton[5]
aButton[1] = .T.
aButton[2] = .F.
aButton[3] = .T.
aButton[4] = .F.
aButton[5] = .F.
cBoxCol = colorof("BOX")
cMsgCol = bright( colorof( "MESSAG" ) )
cBlink = cMsgCol + "*"
nRow = 99999999

clear
do YadTitle
@ 9,22 to 17,57 double color &cBoxCol
@ 9,32 say " Compile Options "
@11,26 say "Selected source ONLY.... ("+ chr(254) + ")"
@12,26 say "ALL source.............. ( )"
@13,26 say "Out-of-date objects ONLY ("+ chr(254) + ")"
@14,26 say "ALL objects............. ( )"
@15,26 say "RunTime validation...... ( )"
@24,7 say "Navigate: " + chr(25) + chr(24) + ;
"    SpaceBar: Select    Ctrl-End: Accept    Esc: Abort" color &cMsgCol
nKey=0
nChosen=0
nButton = 1
@ 11,52 say ""
set cursor on
do while nKey # 23 .and. nKey # 27 .and. nKey # -9
    nKey=inkey(0)
    do case
    case nKey=32   && spacebar
        do YadButto
    case nKey=5 .and. nButton > 1   && uparrow
        nButton = nButton - 1
    case nKey=24 .and. nButton < 5  && downarrow
        nButton = nButton + 1
    endcase
    @10+nButton,52 say ""
enddo
if lastkey() = 27
    do YadResto
    cancel
endif
set cursor off

@ 9,0 clear to 24,79
@11,23 to 15,56 double color &cBoxCol
if aButton[1]
    @13,26 say "File skeleton " + chr(16) get cSkeleton FUNCTION "!";
    message "Enter file skeleton. Wildcards OK.   Ctrl-End: Accept   Esc: Abort"
    set cursor on
    read
    set cursor off
    if lastkey() = 27
        do YadResto
        cancel
    endif
    cSkeleton=ltrim(rtrim(cSkeleton))
else
    cSkeleton="*.*"
endif

@11,0 clear to 24,79
@24,33 say "W O R K I N G" color &cBlink
activate window wCompile
@0,0 say ""
?? "* Creating array of filenames: " + cSkeleton
declare aCompile[ 1170 ]
nFiles =  YadArray(cSkeleton)
if nFiles = 0
    do YadMsg with chr(7) + "No files matching " + cSkeleton
    i=inkey(5)
    do YadResto
    cancel
endif

on error do yadwarn
n = 1
do while n <= nFiles
    do YadProce with aCompile[ n ]
    n = n + 1
enddo
on error

activate screen
@24,23 say "Done! Press any key to continue..." + chr(7) color &cMsgCol
set cursor on
i = inkey(0)
do YadResto
RETURN

PROCEDURE YadTitle
@ 2,10 say "Y A D B M U * Yet Another Dbase Make Utility"
@ 3,10 to 3,53
RETURN

PROCEDURE YadProce
parameter cSourceName
cPrefix = left( cSourceName, at( ".", cSourceName ) - 1 )
cExt = right( cSourceName, 3 )
do case
case cExt = "PRG"
    cObjExt = "DBO"
case cExt = "FRG"
    cObjExt = "FRO"
case cExt = "LBG"
    cObjExt = "LBO"
case cExt = "FMT"
    cObjExt = "FMO"
case cExt = "QBE"
    cObjExt = "QBO"
case cExt = "PRS"
    cObjExt = "DBO"
endcase
cObjName = cPrefix + "." + cObjExt
if aButton[3]
    lObjExist = file( cObjName )
    if lObjExist
        dSource = fdate( cSourceName )
        dObj = fdate( cObjName )
        nSource = time2sec( ftime( cSourceName ) )
        nObj = time2sec( ftime( cObjName ) )
        lCompile = dObj < dSource .or. (dObj = dSource .and. nObj < nSource)
    else
        lCompile = .T.
    endif
else
    lCompile = .T.
    lObjExist = .T.
endif

if lCompile
    store .f. to lReName, lReNameDBO
    lLoop = .t.
    do while lLoop
        if aButton[3]
            if .not. lObjExist
                do YadMsg with cSourceName + "'s " + cObjExt + ;
                 " not found. Recompiling."
            else
                do YadMsg with cSourceName + " created later than " + ;
                "it's " + cObjExt + ". Recompiling."
            endif
        else
            do YadMsg with "Compiling " + cSourceName + "."
        endif
        if cExt $ "|FRG|LBG|"
            lReName = .T.
            if file(cPrefix+".DBO")
                lReNameDBO = .t.
                rename (cPrefix+".DBO") to (cTmpReName)
            endif
        endif
        if lQedit
            set alternate to (iif("" # cDBTMP, cDBTMP + "\yadbmu.txt", "yadbmu.txt"))
            set alternate on
        endif

        do case
        case cExt = "QBE"
            if file( cObjName )
                erase ( cObjName )
            endif
            set talk on
            set view to (cSourceName)
            close databases
        case cExt = "FMT"
            if file( cObjName )
                erase ( cObjName )
            endif
            set talk on
            set format to (cSourceName)
            set format to
        otherwise
            set talk on
            if aButton[5]
                compile (cSourceName) runtime
            else
                compile (cSourceName)
            endif
        endcase
        set talk off

        if lQedit
            set alternate off
            set alternate to
        endif
        if cerror() > 0
            cResponse = YadEdit()
            if cResponse = "E"
                nRow = row()
                save screen to sCompScr
                deactivate window wCompile
                clear
                set console off
                if lQedit
                    cLineNo = YadErrLi()
                    set cursor on
                    run Q.exe &cSourceName. -n&cLineNo.
                    set cursor off
                else
                    set cursor on
                    MODIFY COMMAND &cSourceName
                    set cursor off
                endif
                set console on
                do YadTitle
                @24,33 say "W O R K I N G" color &cBlink
                activate window wCompile
                restore screen from sCompScr
                release screen sCompScr
                @nRow,0 say ""
            else
                lLoop = .f.
            endif
        else
            if lQedit
                erase (iif("" # cDBTMP, cDBTMP + "\yadbmu.txt", "yadbmu.txt"))
            endif
            lLoop = .f.
        endif
    enddo
    if lReName
        if file(cObjName)
            erase (cObjName)
        endif
        rename (cPreFix +".DBO") to (cObjName)
        if lReNameDBO .and. file(cTmpReName)
            rename (cTmpReName) to (cPreFix +".DBO")
        endif
    endif
endif
RETURN

PROCEDURE YadResto
release menu YadEdit
release window YadEdit
release window wCompile
release aCompile
set talk &cTalkStat
set status &cStatStat
set deleted &cDeleStat
set safety &cSafeStat
set cursor on
RETURN

PROCEDURE YadButto
do case
case nButton=1
    aButton[1] = .T.
    aButton[2] = .F.
    @ 11,52 say chr(254)
    @ 12,52 say " "
    @ 11,52 say ""
case nButton=2
    aButton[1] = .F.
    aButton[2] = .T.
    @ 11,52 say " "
    @ 12,52 say chr(254)
    @ 12,52 say ""
case nButton=3
    aButton[3] = .T.
    aButton[4] = .F.
    @ 13,52 say chr(254)
    @ 14,52 say " "
    @ 13,52 say ""
case nButton=4
    aButton[3] = .F.
    aButton[4] = .T.
    @ 13,52 say " "
    @ 14,52 say chr(254)
    @ 14,52 say ""
case nButton=5
    aButton[5] = .not. aButton[5]
    @ 15,52 say iif(aButton[5], chr(254), " ")
    @ 15,52 say ""
endcase
RETURN

FUNCTION YadErrLi
private nFH, lClosed, nStart, nChars, cLineNo
cLineNo = "1"
cLine = ""
nFH = fopen( iif("" # cDBTMP, cDBTMP + "\yadbmu.txt", "yadbmu.txt") )
do while .not. "on line" $ cLine .and. .not. feof( nFH )
    cLine = fgets( nFH )
enddo
lClosed = fclose( nFH )
nStart = at( "on line", cLine ) + 8
if nStart > 8
    nChars = at( ":", cLine ) - nStart
    cLineNo = substr( cLine, nStart, nChars)
endif
erase (iif("" # cDBTMP, cDBTMP + "\yadbmu.txt", "yadbmu.txt"))
RETURN cLineNo

PROCEDURE YadMsg
parameters cMsg
?
? "* " + cMsg at 0
RETURN

FUNCTION YadArray
parameters cFname

if .not. lBIN

set printer to file (cBIN + ".bin")
??? "{140}{200}{142}{216}{137}{14}{216}{2}{131}{249}{2}{125}{6}{184}{162}"+;
"{255}{233}{165}{0}{232}{177}{0}{141}{22}{222}{2}{180}{26}{205}{33}{38}{197}"+;
"{53}{232}{193}{0}{61}{1}{0}{180}{79}{117}{23}{51}{201}{46}{131}{62}{216}"+;
"{2}{3}{124}{7}{38}{197}{117}{8}"
??? "{232}{231}{0}{38}{197}{85}{4}{180}{78}{205}{33}{80}{156}{140}{200}{142}"+;
"{216}{232}{137}{0}{157}{88}{114}{103}{131}{62}{216}{2}{2}{114}{94}{6}{87}"+;
"{38}{196}{125}{4}{141}{54}{252}{2}{232}{83}{2}{95}{7}{131}{62}{216}{2}{3}"+;
"{114}{72}{6}{87}{38}{196}{125}"
??? "{8}{232}{237}{0}{95}{7}{131}{62}{216}{2}{4}{114}{54}{6}{87}{38}{196}"+;
"{125}{12}{232}{75}{1}{95}{7}{131}{62}{216}{2}{5}{114}{36}{6}{87}{38}{196}"+;
"{125}{16}{232}{129}{1}{95}{7}{131}{62}{216}{2}{6}{114}{18}{161}{248}{2}{139}"+;
"{22}{250}{2}{6}{87}{38}{196}{125}"
??? "{20}{232}{167}{1}{95}{7}{51}{192}{131}{62}{216}{2}{1}{114}{7}{38}{196}"+;
"{61}{153}{232}{149}{1}{203}{6}{180}{47}{205}{33}{137}{30}{218}{2}{140}{6}"+;
"{220}{2}{7}{195}{30}{139}{22}{218}{2}{142}{30}{220}{2}{180}{26}{205}{33}"+;
"{31}{195}{87}{51}{192}{139}{216}"
??? "{185}{10}{0}{139}{248}{252}{172}{60}{32}{116}{251}{60}{48}{117}{3}{172}"+;
"{235}{249}{60}{43}{116}{5}{60}{45}{117}{2}{71}{172}{60}{48}{114}{15}{60}"+;
"{57}{119}{11}{44}{48}{152}{147}{247}{233}{3}{216}{172}{235}{237}{139}{195}"+;
"{11}{255}{116}{2}{247}{216}{95}"
??? "{195}{51}{201}{252}{235}{54}{36}{223}{60}{82}{117}{5}{131}{201}{1}{235}"+;
"{43}{60}{72}{117}{5}{131}{201}{2}{235}{34}{60}{83}{117}{5}{131}{201}{4}{235}"+;
"{25}{60}{86}{117}{5}{131}{201}{8}{235}{16}{60}{68}{117}{5}{131}{201}{16}"+;
"{235}{7}{60}{65}{117}{3}{131}"
??? "{201}{32}{172}{10}{192}{117}{197}{195}{38}{128}{61}{0}{116}{105}{138}"+;
"{38}{243}{2}{246}{196}{1}{116}{11}{38}{198}{5}{82}{71}{38}{128}{61}{0}{116}"+;
"{85}{246}{196}{2}{116}{11}{38}{198}{5}{72}{71}{38}{128}{61}{0}{116}{69}{246}"+;
"{196}{4}{116}{11}{38}{198}"
??? "{5}{83}{71}{38}{128}{61}{0}{116}{53}{246}{196}{8}{116}{11}{38}{198}{5}"+;
"{86}{71}{38}{128}{61}{0}{116}{37}{246}{196}{16}{116}{11}{38}{198}{5}{68}"+;
"{71}{38}{128}{61}{0}{116}{21}{246}{196}{32}{116}{11}{38}{198}{5}{65}{71}"+;
"{38}{128}{61}{0}{116}{5}{176}{32}"
??? "{232}{250}{0}{195}{161}{246}{2}{177}{5}{37}{224}{1}{211}{232}{212}{10}"+;
"{134}{224}{5}{48}{48}{171}{38}{198}{5}{47}{71}{161}{246}{2}{37}{31}{0}{212}"+;
"{10}{134}{224}{5}{48}{48}{171}{38}{198}{5}{47}{71}{161}{246}{2}{37}{0}{254}"+;
"{177}{9}{211}{232}{5}{80}{0}"
??? "{61}{100}{0}{124}{3}{45}{100}{0}{212}{10}{134}{224}{5}{48}{48}{171}{195}"+;
"{161}{244}{2}{177}{11}{37}{0}{248}{211}{232}{212}{10}{134}{224}{5}{48}{48}"+;
"{171}{38}{198}{5}{58}{71}{161}{244}{2}{177}{5}{37}{224}{7}{211}{232}{212}"+;
"{10}{134}{224}{5}{48}{48}{171}"
??? "{38}{198}{5}{58}{71}{161}{244}{2}{37}{31}{0}{209}{224}{212}{10}{134}"+;
"{224}{5}{48}{48}{171}{195}{38}{128}{61}{0}{116}{86}{139}{239}{51}{246}{80}"+;
"{176}{32}{232}{98}{0}{88}{185}{10}{0}{11}{210}{125}{8}{70}{247}{210}{247}"+;
"{216}{131}{218}{255}{79}{139}{216}"
??? "{139}{194}{51}{210}{247}{241}{147}{247}{241}{135}{211}{128}{195}{48}"+;
"{38}{136}{29}{59}{253}{116}{15}{11}{192}{117}{228}{11}{246}{116}{28}{79}"+;
"{38}{198}{5}{45}{235}{21}{11}{210}{117}{10}{11}{192}{117}{6}{11}{246}{117}"+;
"{2}{235}{7}{139}{253}{176}{42}{232}"
??? "{22}{0}{195}{252}{172}{10}{192}{116}{9}{38}{128}{61}{0}{116}{8}{170}"+;
"{235}{242}{176}{32}{232}{1}{0}{195}{252}{235}{1}{170}{38}{128}{61}{0}{117}"+;
"{249}{195}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
"{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"
??? "{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"

endif

set printer to
set printer to nul
set printer off

cFname = cFname + space(12)
load &cBIN.
n = 1
nResult = call( cModule, 1, cFname )
if nResult=0
    do while nResult = 0
        if ( "." $ cFname ) .and. .not. "YADBMU" $ cFname .and. ;
        trim( substr( cFname, at( ".", cFname ), 4 ) ) $ ;
        "|.PRG|.FRG|.LBG|.FMT|.QBE|.PRS"
            aCompile[ n ] = trim( cFname )
            n = n + 1
        endif
        nResult = call( cModule, 2, cFname )
    enddo
endif
release modules
if .not. lBIN
    erase (cBIN + ".bin")
endif
RETURN ( n - 1 )

PROCEDURE YadMenu
define window wCompile from 5,10 to 21,69 double
define window YadEdit from 20,39 to 23,71 double
define menu YadEdit message ;
 space(34) + "Navigate: " + chr(27) + chr(26) + "   Select: " + ;
 chr(17) + chr(196) + chr(217)
define pad pad1 of YadEdit prompt "EDIT" at 0,6
define pad pad2 of YadEdit prompt "IGNORE" at 0,19
on selection pad pad1 of YadEdit do YadSet with "E"
on selection pad pad2 of YadEdit do YadSet with "I"
RETURN

FUNCTION YadEdit
cChoice = ""
on key label E do YadSet with "E"
on key label I do YadSet with "I"
activate window YadEdit
@1,3 say "Edit file or ignore error?"
activate menu YadEdit
deactivate window YadEdit
RETURN cChoice
*-- EoFunc YadEdit

PROCEDURE YadSet
parameter c_Choice
cChoice = c_Choice
on key label E
on key label I
deactivate menu
RETURN
*-- EoP YadSet

PROCEDURE yadwarn
set bell to 880,1
?? ""
set bell to 1400,1
?? ""
set bell to 880,1
?? ""
set bell to
RETURN

FUNCTION VerLevel
*-------------------------------------------------------------------------------
*-- Programmer..: Bowen Moursund
*-- Date........: 06-24-1992
*-- Written for.: dBASE IV, 1.5
*-- Rev. History: None
*-- Calls.......: None
*-- Called by...: Any
*-- Usage.......: VerLevel()
*-- Example.....: if VerLevel() >= 1.5
*-- Returns.....: a numeric equivalent of Version()
*-- Parameters..: None
*-------------------------------------------------------------------------------

    private cVersion, nPos
    cVersion = version()
    nPos = 1
    do while left(right(cVersion,nPos),1) # " "
        nPos = nPos + 1
    enddo

RETURN val(right(cVersion,nPos+1))
*-- Eof() VerLevel

FUNCTION Time2Sec
*-------------------------------------------------------------------------------
*-- Programmer..: Jay Parsons (JPARSONS)
*-- Date........: 03/01/92
*-- Notes.......: Convert HH:MM:SS or HH:MM:SS.SS string to seconds.
*-- Written for.: dBASE IV
*-- Rev. History: None
*-- Calls.......: None
*-- Called by...: Any
*-- Usage.......: Time2Sec("<cTime>")
*-- Example.....: ?Time2Sec("01:24:15")
*-- Returns.....: Numeric
*-- Parameters..: cTime = Time string in format HH:MM:SS or HH:MM:SS.SS
*-------------------------------------------------------------------------------

parameters cTime
private cTemp, nSecs
cTemp = cTime
nSecs = 3600 * val( cTemp )
cTemp = substr( cTemp, at( ":", cTemp ) + 1 )
nSecs = nSecs + 60 * val( cTemp )

RETURN nSecs + val( substr( cTemp, at( ":", cTemp ) + 1 ) )
*-- EoF: Time2Sec()

FUNCTION ColorOf
*-------------------------------------------------------------------------------
*-- Programmer..: Jay Parsons (JPARSONS)
*-- Date........: 01/11/1992
*-- Notes.......: This function will return the color of a specified area
*--               (as built in to dBASE). 
*-- Written for.: dBASE IV, 1.1
*-- Rev. History: None
*-- Calls.......: ALLTRIM()            Function in PROC.PRG
*-- Called by...: Any
*-- Usage.......: ColorOf("<cArea>")
*-- Example.....: ?ColorOf("Messages")
*-- Returns.....: Color (foreground/background)
*-- Parameters..: cArea = Area you wish to return the color of from list:
*--               BOX/BOXES        = Boxes
*--               BORDER/PERIMETER = Border color
*--               NORMAL           = Normal screen/text
*--               HIGHLIGHT        = Highlights
*--               MESSAGE          = Messages
*--               TITLE            = Titles
*--               INFORMATION      = Information
*--               FIELDS           = Fields
*-------------------------------------------------------------------------------

parameters cArea

private cAttrib, cWanted, nPos

cAttrib = set("ATTRIBUTES")
cWanted = upper(ltrim(rtrim(cArea)))

if cWanted = "BOX"
    nPos = 6
else
    nPos = at(left(cWanted,4),;
    "    NORM HIGH PERI MESS TITL BOXE INFO FIEL BORD") / 5
    if nPos = 9
        nPos = 3    && "Border" = "Perimeter"
    endif
endif

do case
case nPos = 0
    cAttrib = ""  && return null string for error
case nPos < 4
    cAttrib = left(cAttrib,at("&",cAttrib) - 2)
otherwise
    cAttrib = substr(cAttrib,at("&",cAttrib) + 3)
    nPos = nPos - 3
endcase
do while nPos > 1
    cAttrib = substr(cAttrib,at(",",cAttrib) + 1)
    nPos = nPos - 1
enddo

RETURN left(cAttrib,at(",",cAttrib+",")-1)
*-- EoF: ColorOf()

FUNCTION YadTemp
*-------------------------------------------------------------------------------
*-- Programmer..: Martin Leon (HMAN)  Former Sysop, ATBBS
*-- Date........: 05-27-1992
*-- Notes.......: Obtain a name for a temporary file of a given extension
*--               that does not conflict with existing files.
*-- Written for.: dBASE IV, v1.5
*-- Rev. History: Originally part of Makestru(), 6-12-1991
*--               04/26/92, made a separate function - Jay Parsons
*--               05/27/92, added lDBTMP option - Bowen Moursund
*-- Calls.......: None
*-- Called by...: Any
*-- Usage.......: TempName( cExt , lDBTMP )
*-- Example.....: Sortfile = TempName( "DBF" , .t. )
*-- Returns.....: Name not already in use. Additionally, if the memvar
*--               cDBTMP is declared before calling the function with
*--               the lDBTMP option, it will be assigned the result
*--               of getenv("DBTMP").
*-- Parameters..: cExt   = Extension to be given file ( without the "." )
*--               lDBTMP = Optional. If .t., function returns unique file
*--                        name in the DBTMP subdirectory.
*-- Side Effects: The function will return a unique filename for the DEFAULT
*--               subdirectory if the lDBTMP option is used and the DOS
*--               environment variable DBTMP does not point to a valid
*--               subdirectory.
*-------------------------------------------------------------------------------

   parameters cExt, lDBTMP
   private cDefDir
   cDefDir = set("DIRECTORY")
   if lDBTMP
      cDBTMP = getenv("DBTMP")
      if "" # cDBTMP
         set directory to &cDBTMP.
      endif
   endif
   do while .t.
      Fname = "TMP" + ltrim( str( rand() * 100000, 5 ) )
      if .not. file( Fname + "." + cExt ) .and. ( upper( cExt ) # "DBF" .or.;
         .not. ( file( Fname + ".MDX" ) .or. file ( Fname + ".DBT" ) ) )
            exit
      endif
   enddo
   set directory to &cDefDir.

RETURN Fname
*-- Eof() TempName

FUNCTION Bright
*-------------------------------------------------------------------------------
*-- Programmer..: Bowen Moursund
*-- Date........: 07-30-1992
*-- Notes.......: Bright() converts a dBASE color attribute string to
*--               a bright (+) foreground.
*-- Written for.: dBASE IV v1.5
*-- Rev. History: None
*-- Calls.......: None
*-- Called by...: Any
*-- Usage.......: Bright( <cExp> )
*-- Example.....: cBriteMsg = bright( ColorOf( "MESSAG" ) )
*-- Returns.....: A color attribute string converted to bright foreground.
*-- Parameters..: <cExp> = cColor: a dBASE color attribute string
*-------------------------------------------------------------------------------

    parameter cColor

RETURN iif( "+" $ cColor, cColor, cColor + "+" )
*-- EoF: Bright()

*-- EoF: yadbmu.prg
